Index: orxonox/trunk/importer/array.cc
===================================================================
--- orxonox/trunk/importer/array.cc	(revision 2838)
+++ orxonox/trunk/importer/array.cc	(revision 2842)
@@ -16,10 +16,17 @@
 #include "array.h"
 
+/**
+   \brief creates a new Array
+*/
 Array::Array ()
 {
-  createArray ();
+  initializeArray ();
 }
 
-void Array::createArray ()
+/**
+   \brief initializes an Array
+   the Function does this by setting up a fistEntry, and setting the entryCount.
+*/
+void Array::initializeArray ()
 {
   if (verbose >= 2)
@@ -33,4 +40,8 @@
 }
 
+/**
+   \brief finalizes an array.
+   This Function creates the array, and makes it ready to be sent to the application.
+*/
 void Array::finalizeArray (void)
 {
@@ -49,5 +60,8 @@
 }
 
-
+/**
+   \brief adds a new Entry to the Array
+   \param entry Entry to add.
+*/
 void Array::addEntry (GLfloat entry)
 {
@@ -68,4 +82,7 @@
 }
 
+/**
+   \brief Adds 3 entries at once (convenience)
+*/
 void Array::addEntry (GLfloat entry0, GLfloat entry1, GLfloat entry2)
 {
@@ -75,5 +92,8 @@
 }
   
-
+/**
+   \brief Gives back the array !! MUST be executed AFTER finalize.
+   \returns The created array.
+*/
 GLfloat* Array::getArray ()
 {
@@ -81,4 +101,7 @@
 }
 
+/**
+   \returns The Count of entries in the Array
+*/
 int Array::getCount()
 {
@@ -86,6 +109,7 @@
 }
 
-
-
+/**
+   \brief Simple debug info about the Array
+*/
 void Array::debug ()
 {
Index: orxonox/trunk/importer/array.h
===================================================================
--- orxonox/trunk/importer/array.h	(revision 2838)
+++ orxonox/trunk/importer/array.h	(revision 2842)
@@ -1,10 +1,20 @@
+/*!
+  \file array.h
+  \brief Contains the Array Class that handles float arrays.
+  this class creates a Array of a semi-Dynamic length.
+  beware, that after finalizing the array may not be resized again.
+*/
+
 #ifndef _ARRAY_H
 #define _ARRAY_H
 
-extern int verbose;
+extern int verbose; //!< will be obsolete soon
 
 #include <GL/gl.h>
 #include <GL/glu.h>
 #include <fstream>
+
+
+//! Array Class that handles dynamic-float arrays.
 class Array
 {
@@ -12,5 +22,5 @@
   Array ();
 
-  void createArray ();
+  void initializeArray ();
   void finalizeArray (void);
   void addEntry (GLfloat entry);
Index: orxonox/trunk/importer/material.cc
===================================================================
--- orxonox/trunk/importer/material.cc	(revision 2838)
+++ orxonox/trunk/importer/material.cc	(revision 2842)
@@ -16,4 +16,8 @@
 #include "material.h"
 
+/**
+   \brief creates a default Material with no Name
+   normally you call this to create a material List (for an obj-file) and then append with addMaterial()
+*/
 Material::Material()
 {
@@ -23,4 +27,8 @@
 }
 
+/**
+   \brief creates a Material.
+   \param mtlName Name of the Material to be added to the Material List
+*/
 Material::Material (char* mtlName)
 {
@@ -30,4 +38,9 @@
 }
 
+/**
+   \brief adds a new Material to the List.
+   this Function will append a new Material to the end of a Material List.
+   \param mtlName The name of the Material to be added.
+*/
 Material* Material::addMaterial(char* mtlName)
 {
@@ -45,4 +58,7 @@
 }
 
+/**
+   \brief initializes a new Material with its default Values
+*/
 void Material::init(void)
 {
@@ -60,5 +76,8 @@
 }
 
-
+/**
+   \brief Set the Name of the Material. (Important for searching)
+   \param mtlName the Name of the Material to be set.
+*/ 
 void Material::setName (char* mtlName)
 {
@@ -69,4 +88,7 @@
 
 }
+/**
+   \returns The Name of The Material
+*/
 char* Material::getName (void)
 {
@@ -74,5 +96,8 @@
 }
 
-
+/**
+   \brief Sets the Material Illumination Model. 
+   \brief illu illumination Model in int form
+*/
 void Material::setIllum (int illum)
 {
@@ -82,9 +107,18 @@
   //  printf ("setting illumModel to: %i\n", illumModel);
 }
-void Material::setIllum (char* illum)
+/**
+   \brief Sets the Material Illumination Model. 
+   \brief illu illumination Model in char* form
+*/void Material::setIllum (char* illum)
 {
   setIllum (atoi(illum));
 }
 
+/**
+   \brief Sets the Material Diffuse Color.
+   \param r Red Color Channel.
+   \param g Green Color Channel.
+   \param b Blue Color Channel.
+*/
 void Material::setDiffuse (float r, float g, float b)
 {
@@ -97,4 +131,8 @@
 
 }
+/**
+   \brief Sets the Material Diffuse Color.
+   \param rgb The red, green, blue channel in char format (with spaces between them)
+*/
 void Material::setDiffuse (char* rgb)
 {
@@ -104,4 +142,10 @@
 }
 
+/**
+   \brief Sets the Material Ambient Color. 
+   \param r Red Color Channel.
+   \param g Green Color Channel.
+   \param b Blue Color Channel.
+*/
 void Material::setAmbient (float r, float g, float b)
 {
@@ -113,4 +157,8 @@
   ambient[3] = 1.0;
 }
+/**
+   \brief Sets the Material Ambient Color.
+   \param rgb The red, green, blue channel in char format (with spaces between them)
+*/
 void Material::setAmbient (char* rgb)
 {
@@ -120,4 +168,10 @@
 }
 
+/**
+   \brief Sets the Material Specular Color. 
+   \param r Red Color Channel.
+   \param g Green Color Channel.
+   \param b Blue Color Channel.
+*/
 void Material::setSpecular (float r, float g, float b)
 {
@@ -129,4 +183,8 @@
   specular[3] = 1.0;
  }
+/**
+   \brief Sets the Material Specular Color.
+   \param rgb The red, green, blue channel in char format (with spaces between them)
+*/
 void Material::setSpecular (char* rgb)
 {
@@ -136,8 +194,16 @@
 }
 
+/**
+   \brief Sets the Material Shininess.
+   \param shini stes the Shininess from float.
+*/
 void Material::setShininess (float shini)
 {
   shininess = shini;
 }
+/**
+   \brief Sets the Material Shininess.
+   \param shini stes the Shininess from char*.
+*/
 void Material::setShininess (char* shini)
 {
@@ -145,4 +211,8 @@
 }
 
+/**
+   \brief Sets the Material Transparency.
+   \param trans stes the Transparency from int.
+*/
 void Material::setTransparency (float trans)
 {
@@ -151,4 +221,8 @@
   transparency = trans;
 }
+/**
+   \brief Sets the Material Transparency.
+   \param trans stes the Transparency from char*.
+*/
 void Material::setTransparency (char* trans)
 {
@@ -158,5 +232,9 @@
 }
 
-
+/**
+   \brief Search for a Material called mtlName
+   \param mtlName the Name of the Material to search for
+   \returns Material named mtlName if it is found. NULL otherwise.
+*/
 Material* Material::search (char* mtlName)
 {
@@ -179,4 +257,7 @@
 }
 
+/**
+   \brief sets the material with which the following Faces will be painted
+*/
 bool Material::select (void)
 {
Index: orxonox/trunk/importer/material.h
===================================================================
--- orxonox/trunk/importer/material.h	(revision 2838)
+++ orxonox/trunk/importer/material.h	(revision 2842)
@@ -1,6 +1,11 @@
+/*!
+  \file material.h
+  \brief Contains the Material Class that handles Material for 3D-Objects.
+*/
+
 #ifndef _MATERIAL_H
 #define _MATERIAL_H
 
-extern int verbose;
+extern int verbose; //!< will be obsolete soon.
 
 #include <GL/gl.h>
@@ -9,4 +14,5 @@
 #include <fstream>
 
+//! Class to handle Materials.
 class Material
 {
@@ -39,5 +45,5 @@
   bool select (void);
 
-  Material* nextMat;
+  Material* nextMat; //!< pointer to the Next Material of the List. NULL if no next exists.
 
  private:
Index: orxonox/trunk/importer/object.cc
===================================================================
--- orxonox/trunk/importer/object.cc	(revision 2838)
+++ orxonox/trunk/importer/object.cc	(revision 2842)
@@ -16,14 +16,22 @@
 #include "object.h"
 
+/**
+   \brief Creates a 3D-Object, but does not load any 3D-models
+   pretty useless
+*/
 Object::Object ()
 {
 
   initialize();
-
-  importFile ("reaphigh.obj");
+  
+  importFile ("");
 
   finalize();
 }
 
+/**
+   \brief Crates a 3D-Object and loads in a File
+   \param fileName file to parse and load (must be a .obj file)
+*/
 Object::Object(char* fileName)
 {
@@ -34,4 +42,10 @@
   finalize();
 }
+
+/**
+   \brief Crates a 3D-Object, loads in a File and scales it.
+   \param fileName file to parse and load (must be a .obj file)
+   \param scaling The factor that the object will be scaled with.
+*/
 
 Object::Object(char* fileName, float scaling)
@@ -45,4 +59,8 @@
 }
 
+/** 
+    \brief initializes the Object
+    This Function initializes all the needed arrays, Lists and clientStates
+*/
 bool Object::initialize (void)
 {
@@ -70,4 +88,8 @@
 }
 
+/**
+   \brief Imports a obj file and handles the the relative location
+   \param fileName The file to import
+*/
 bool Object::importFile (char* fileName)
 {
@@ -79,4 +101,8 @@
 }
 
+/**
+   \brief finalizes an Object.
+   This funcion is needed, to close the glList and all the other lists.
+*/
 bool Object::finalize(void)
 {
@@ -89,4 +115,8 @@
 }
 
+/**
+   \brief Draws the Object
+   It does this by just calling the List that must have been created earlier.
+*/
 void Object::draw (void)
 {
@@ -96,5 +126,9 @@
 }
 
-
+/**
+   \brief Reads in the .obj File and sets all the Values.
+   This function does read the file, parses it for the occurence of things like vertices, faces and so on, and executes the specific tasks
+   \param fileName the File that will be parsed (.obj-file)
+*/
 bool Object::readFromObjFile (char* fileName)
 {
@@ -158,5 +192,9 @@
 }
 
-
+/**
+   \brief parses a vertex-String
+   If a vertex line is found this function will inject it into the vertex-Array
+   \param vertexString The String that will be parsed.
+*/
 bool Object::readVertex (char* vertexString)
 {
@@ -172,4 +210,10 @@
 }
 
+/**
+   \brief parses a face-string
+   If a face line is found this function will add it to the glList.
+   The function makes a difference between QUADS and TRIANGLES, and will if changed re-open, set and re-close the gl-processe.
+   \param faceString The String that will be parsed.
+*/
 bool Object::readFace (char* faceString)
 {
@@ -225,4 +269,13 @@
 }
 
+/**
+   \brief Adds a Face-element (one vertex of a face) with all its information. 
+   It does this by searching:
+   1. The Vertex itself
+   2. The VertexNormale
+   3. The VertexTextureCoordinate
+   merging this information, the face will be drawn.
+
+*/
 bool Object::addGLElement (char* elementString)
 {
@@ -249,4 +302,9 @@
 }
 
+/**
+   \brief parses a vertexNormal-String
+   If a vertexNormal line is found this function will inject it into the vertexNormal-Array
+   \param normalString The String that will be parsed.
+*/
 bool Object::readVertexNormal (char* normalString)
 {
@@ -262,4 +320,9 @@
 }
 
+/**
+   \brief parses a vertexTextureCoordinate-String
+   If a vertexTextureCoordinate line is found this function will inject it into the vertexTexture-Array
+   \param vTextureString The String that will be parsed.
+*/
 bool Object::readVertexTexture (char* vTextureString)
 {
@@ -275,5 +338,9 @@
 }
 
-
+/** 
+    \brief Function to read in a mtl File.
+    this Function parses all Lines of an mtl File
+    \param mtlFile The .mtl file to read
+*/
 bool Object::readMtlLib (char* mtlFile)
 {
@@ -345,4 +412,9 @@
 }
 
+/**
+   \brief Function that selects a material, if changed in the obj file.
+   \param matString the Material that will be set.
+*/
+
 bool Object::readUseMtl (char* matString)
 {
@@ -362,5 +434,8 @@
 }
 
-
+/**
+   \brief Includes a default object
+   This will inject a Cube, because this is the most basic object.
+*/
 void Object::BoxObject(void)
 {
Index: orxonox/trunk/importer/object.h
===================================================================
--- orxonox/trunk/importer/object.h	(revision 2838)
+++ orxonox/trunk/importer/object.h	(revision 2842)
@@ -1,5 +1,5 @@
 /*!
- \file object.h
- \brief Contains the Object Class that handles 3D-Objects
+  \file object.h
+  \brief Contains the Object Class that handles 3D-Objects
 */
 
@@ -15,5 +15,7 @@
 
 using namespace std;
-extern int verbose;
+
+extern int verbose; //!< fill be removed and added again as a verbose-class
+
 
 //! Class that handles 3D-Objects. it can also read them in and display them.